package OTPGen;

import javax.microedition.rms.*;
import java.io.*;

public class AccountComparator implements RecordComparator {
	/* Data in a record:
	 * Seed: String
	 * Seq: int
	 * hash: int
	 */

	ByteArrayInputStream stream;
	DataInputStream reader;

	String s1, s2;

	public int compare(byte[] a, byte[] b) {
		// compare seeds only, that'll do
		try {
			stream = new ByteArrayInputStream(a);
			reader = new DataInputStream(stream);
			s1 = reader.readUTF();

			stream = new ByteArrayInputStream(b);
			reader = new DataInputStream(stream);
			s2 = reader.readUTF();
		}
		catch (Exception e) {
			// debug, he?
			// System.out.println(e.toString());
		}
		finally {
			if (s1.equals(s2)) {
				return AccountComparator.EQUIVALENT;
			} else if (s1.compareTo(s2) < 0) {
				return AccountComparator.PRECEDES;
			} else {
				return AccountComparator.FOLLOWS;
			}
		}
	}
}
