package OTPGen;

/* A simplistic MD5 implementation that works on octets only */
public class MD5 extends MD4 {
	public MD5() {
		super();
	}

	protected synchronized void transformations(int[] X) {
		int _k;

		int aa = a;
		int bb = b;
		int cc = c;
		int dd = d;

		// round 1!
		for(_k = 0; _k < 16;) {
			aa += ((bb & cc) | (~bb & dd)) + X[_k] + T[_k++];
			aa  = ((aa <<  7) | (aa >>> - 7)) + bb;
			dd += ((aa & bb) | (~aa & cc)) + X[_k] + T[_k++];
			dd  = ((dd << 12) | (dd >>> -12)) + aa;
			cc += ((dd & aa) | (~dd & bb)) + X[_k] + T[_k++];
			cc  = ((cc << 17) | (cc >>> -17)) + dd;
			bb += ((cc & dd) | (~cc & aa)) + X[_k] + T[_k++];
			bb  = ((bb << 22) | (bb >>> -22)) + cc;
		}

		// round 2!
		aa += ((bb & dd) | (cc & ~dd)) + X[ 1] + T[16];
		aa  = ((aa <<  5) | (aa >>> - 5)) + bb;
		dd += ((aa & cc) | (bb & ~cc)) + X[ 6] + T[17];
		dd  = ((dd <<  9) | (dd >>> - 9)) + aa;
		cc += ((dd & bb) | (aa & ~bb)) + X[11] + T[18];
		cc  = ((cc << 14) | (cc >>> -14)) + dd;
		bb += ((cc & aa) | (dd & ~aa)) + X[ 0] + T[19];
		bb  = ((bb << 20) | (bb >>> -20)) + cc;

		aa += ((bb & dd) | (cc & ~dd)) + X[ 5] + T[20];
		aa  = ((aa <<  5) | (aa >>> - 5)) + bb;
		dd += ((aa & cc) | (bb & ~cc)) + X[10] + T[21];
		dd  = ((dd <<  9) | (dd >>> - 9)) + aa;
		cc += ((dd & bb) | (aa & ~bb)) + X[15] + T[22];
		cc  = ((cc << 14) | (cc >>> -14)) + dd;
		bb += ((cc & aa) | (dd & ~aa)) + X[ 4] + T[23];
		bb  = ((bb << 20) | (bb >>> -20)) + cc;

		aa += ((bb & dd) | (cc & ~dd)) + X[ 9] + T[24];
		aa  = ((aa <<  5) | (aa >>> - 5)) + bb;
		dd += ((aa & cc) | (bb & ~cc)) + X[14] + T[25];
		dd  = ((dd <<  9) | (dd >>> - 9)) + aa;
		cc += ((dd & bb) | (aa & ~bb)) + X[ 3] + T[26];
		cc  = ((cc << 14) | (cc >>> -14)) + dd;
		bb += ((cc & aa) | (dd & ~aa)) + X[ 8] + T[27];
		bb  = ((bb << 20) | (bb >>> -20)) + cc;

		aa += ((bb & dd) | (cc & ~dd)) + X[13] + T[28];
		aa  = ((aa <<  5) | (aa >>> - 5)) + bb;
		dd += ((aa & cc) | (bb & ~cc)) + X[ 2] + T[29];
		dd  = ((dd <<  9) | (dd >>> - 9)) + aa;
		cc += ((dd & bb) | (aa & ~bb)) + X[ 7] + T[30];
		cc  = ((cc << 14) | (cc >>> -14)) + dd;
		bb += ((cc & aa) | (dd & ~aa)) + X[12] + T[31];
		bb  = ((bb << 20) | (bb >>> -20)) + cc;


		// round 3, halfway through!
		aa += (bb ^ cc ^ dd) + X[ 5] + T[32];
		aa  = ((aa <<  4) | (aa >>> - 4)) + bb;
		dd += (aa ^ bb ^ cc) + X[ 8] + T[33];
		dd  = ((dd << 11) | (dd >>> -11)) + aa;
		cc += (dd ^ aa ^ bb) + X[11] + T[34];
		cc  = ((cc << 16) | (cc >>> -16)) + dd;
		bb += (cc ^ dd ^ aa) + X[14] + T[35];
		bb  = ((bb << 23) | (bb >>> -23)) + cc;

		aa += (bb ^ cc ^ dd) + X[ 1] + T[36];
		aa  = ((aa <<  4) | (aa >>> - 4)) + bb;
		dd += (aa ^ bb ^ cc) + X[ 4] + T[37];
		dd  = ((dd << 11) | (dd >>> -11)) + aa;
		cc += (dd ^ aa ^ bb) + X[ 7] + T[38];
		cc  = ((cc << 16) | (cc >>> -16)) + dd;
		bb += (cc ^ dd ^ aa) + X[10] + T[39];
		bb  = ((bb << 23) | (bb >>> -23)) + cc;
	
		aa += (bb ^ cc ^ dd) + X[13] + T[40];
		aa  = ((aa <<  4) | (aa >>> - 4)) + bb;
		dd += (aa ^ bb ^ cc) + X[ 0] + T[41];
		dd  = ((dd << 11) | (dd >>> -11)) + aa;
		cc += (dd ^ aa ^ bb) + X[ 3] + T[42];
		cc  = ((cc << 16) | (cc >>> -16)) + dd;
		bb += (cc ^ dd ^ aa) + X[ 6] + T[43];
		bb  = ((bb << 23) | (bb >>> -23)) + cc;

		aa += (bb ^ cc ^ dd) + X[ 9] + T[44];
		aa  = ((aa <<  4) | (aa >>> - 4)) + bb;
		dd += (aa ^ bb ^ cc) + X[12] + T[45];
		dd  = ((dd << 11) | (dd >>> -11)) + aa;
		cc += (dd ^ aa ^ bb) + X[15] + T[46];
		cc  = ((cc << 16) | (cc >>> -16)) + dd;
		bb += (cc ^ dd ^ aa) + X[ 2] + T[47];
		bb  = ((bb << 23) | (bb >>> -23)) + cc;


		// round 4!
		aa += (cc ^ (bb | ~dd)) + X[ 0] + T[48];
		aa  = ((aa <<  6) | (aa >>> - 6)) + bb;
		dd += (bb ^ (aa | ~cc)) + X[ 7] + T[49];
		dd  = ((dd << 10) | (dd >>> -10)) + aa;
		cc += (aa ^ (dd | ~bb)) + X[14] + T[50];
		cc  = ((cc << 15) | (cc >>> -15)) + dd;
		bb += (dd ^ (cc | ~aa)) + X[ 5] + T[51];
		bb  = ((bb << 21) | (bb >>> -21)) + cc;


		aa += (cc ^ (bb | ~dd)) + X[12] + T[52];
		aa  = ((aa <<  6) | (aa >>> - 6)) + bb;
		dd += (bb ^ (aa | ~cc)) + X[ 3] + T[53];
		dd  = ((dd << 10) | (dd >>> -10)) + aa;
		cc += (aa ^ (dd | ~bb)) + X[10] + T[54];
		cc  = ((cc << 15) | (cc >>> -15)) + dd;
		bb += (dd ^ (cc | ~aa)) + X[ 1] + T[55];
		bb  = ((bb << 21) | (bb >>> -21)) + cc;

		aa += (cc ^ (bb | ~dd)) + X[ 8] + T[56];
		aa  = ((aa <<  6) | (aa >>> - 6)) + bb;
		dd += (bb ^ (aa | ~cc)) + X[15] + T[57];
		dd  = ((dd << 10) | (dd >>> -10)) + aa;
		cc += (aa ^ (dd | ~bb)) + X[ 6] + T[58];
		cc  = ((cc << 15) | (cc >>> -15)) + dd;
		bb += (dd ^ (cc | ~aa)) + X[13] + T[59];
		bb  = ((bb << 21) | (bb >>> -21)) + cc;

		aa += (cc ^ (bb | ~dd)) + X[ 4] + T[60];
		aa  = ((aa <<  6) | (aa >>> - 6)) + bb;
		dd += (bb ^ (aa | ~cc)) + X[11] + T[61];
		dd  = ((dd << 10) | (dd >>> -10)) + aa;
		cc += (aa ^ (dd | ~bb)) + X[ 2] + T[62];
		cc  = ((cc << 15) | (cc >>> -15)) + dd;
		bb += (dd ^ (cc | ~aa)) + X[ 9] + T[63];
		bb  = ((bb << 21) | (bb >>> -21)) + cc;


		a += aa; b += bb; c += cc; d += dd;
	}

	static final int[] T = {
		0xd76aa478, 0xe8c7b756, 0x242070db, 0xc1bdceee,
		0xf57c0faf, 0x4787c62a, 0xa8304613, 0xfd469501,
		0x698098d8, 0x8b44f7af, 0xffff5bb1, 0x895cd7be,
		0x6b901122, 0xfd987193, 0xa679438e, 0x49b40821,
		0xf61e2562, 0xc040b340, 0x265e5a51, 0xe9b6c7aa,
		0xd62f105d,  0x2441453, 0xd8a1e681, 0xe7d3fbc8,
		0x21e1cde6, 0xc33707d6, 0xf4d50d87, 0x455a14ed,
		0xa9e3e905, 0xfcefa3f8, 0x676f02d9, 0x8d2a4c8a,
		0xfffa3942, 0x8771f681, 0x6d9d6122, 0xfde5380c,
		0xa4beea44, 0x4bdecfa9, 0xf6bb4b60, 0xbebfbc70,
		0x289b7ec6, 0xeaa127fa, 0xd4ef3085,  0x4881d05,
		0xd9d4d039, 0xe6db99e5, 0x1fa27cf8, 0xc4ac5665,
		0xf4292244, 0x432aff97, 0xab9423a7, 0xfc93a039,
		0x655b59c3, 0x8f0ccc92, 0xffeff47d, 0x85845dd1,
		0x6fa87e4f, 0xfe2ce6e0, 0xa3014314, 0x4e0811a1,
		0xf7537e82, 0xbd3af235, 0x2ad7d2bb, 0xeb86d391 };
}
