package OTPGen;

import javax.microedition.lcdui.*;
#ifndef LITE
import Words.*;
#endif

public class DisplayPassword extends Form implements doAfterCommand
{
	public final static int OK = 0;

	Command cmOk = new Command("Ok", Command.OK, 0);
	CommandListener owner;
	StringItem siHex;

#ifndef LITE
	StringItem siText;
#endif

	public DisplayPassword(String title, byte[] p, CommandListener l) {
		super(title);
		int i;
		String hex = new String();

		hex = "";
		for(i = 0; i < 8; i++) {
			hex += ((((short)p[i] & 0xff) < 16) ? "0" : "") +
				Integer.toHexString(p[i] & 0xff) + " ";
		}


		owner = l;

#ifndef LITE
		siText = new StringItem("Words:", btoe(p));
		append(siText);
#endif

		siHex = new StringItem("HEX:", hex);
		append(siHex);
		addCommand(cmOk);
		
		this.setCommandListener(owner);
	}

	public int doCommand(Command cm) {
		return OK;
	}

#ifndef LITE
	private String btoe(byte[] s) {
		byte sum;
		byte[] cp = new byte[9];
		String str;
		int i;

		// checksum
		sum = 0;
		for(i = 0; i < 64; i += 2)
			sum += extract(s, i, 2);

		for(i = 0; i < 8; i++)
			cp[i] = s[i];
		cp[8] = (byte)(sum << 6);


		str = getWord((int)extract(cp, 0, 11));
		str += " " + getWord((int)extract(cp, 11, 11));
		str += " " + getWord((int)extract(cp, 22, 11));
		str += " " + getWord((int)extract(cp, 33, 11));
		str += " " + getWord((int)extract(cp, 44, 11));
		str += " " + getWord((int)extract(cp, 55, 11));

		return str;
	}

	// FIXME: czy takie rozwizanie w ogle ma sens?
	private String getWord(int i) {
		switch(i/128) {
		 case 0 :	return Words1.w[i%128];
		 case 1 :	return Words2.w[i%128];
		 case 2 :	return Words3.w[i%128];
		 case 3 :	return Words4.w[i%128];
		 case 4 :	return Words5.w[i%128];
		 case 5 :	return Words6.w[i%128];
		 case 6 :	return Words7.w[i%128];
		 case 7 :	return Words8.w[i%128];
		 case 8 :	return Words9.w[i%128];
		 case 9 :	return Words10.w[i%128];
		 case 10 :	return Words11.w[i%128];
		 case 11 :	return Words12.w[i%128];
		 case 12 :	return Words13.w[i%128];
		 case 13 :	return Words14.w[i%128];
		 case 14 :	return Words15.w[i%128];
		 case 15 :	return Words16.w[i%128];
		}
		return "";
//		return Words.w[i];
	}
				
				

	// copied from put.c file from s/key package
	private long extract(byte[] s, int start, int length) {
		byte cl, cc, cr;
		int first, last, x;

		first = start/8;
		last = (start+length-1)/8;

		cl = s[first];
		if (last > first)
		        cc = s[first +1];
		else
			cc = 0;
		if (last - first == 2)
			cr = s[first +2];
		else
			cr = 0;

	        x = ((int)(cl<<8 | (cc & 0xff)) <<8 | (cr & 0xff)) ;
	        x = x >>> (24 - (length + (start %8)));
	        x =( x & (0xffff >>> (16-length) )   );
		return x;
	}
#endif // LITE

}
