package OTPGen;

import javax.microedition.lcdui.*;

public class EnterPassword extends Form
		implements ItemStateListener, doAfterCommand
{
	public final static int OK = 0;
	public final static int CANCEL = -1;

	CommandListener owner;
	Command cmOk, cmCancel;
	TextField tfPassword;

	String password;

	public EnterPassword(String title, CommandListener l) {
		super(title);
		owner = l;

		cmOk = new Command("Ok", Command.OK, 1);
		cmCancel = new Command("Cancel", Command.CANCEL, 2);
		tfPassword = new TextField("Pass Phrase", "", 63, TextField.ANY);
		password = "";

		this.addCommand(cmOk);
		this.addCommand(cmCancel);
		this.append(tfPassword);

		this.setCommandListener(owner);
		this.setItemStateListener(this);
	}

	public void itemStateChanged(Item item) {
		if (item == tfPassword) {
			password = tfPassword.getString();
		}
	}

	public int doCommand(Command c) {
		if (c == cmOk) {
			return OK;
		} else if (c == cmCancel) {
			return CANCEL;
		}
		return CANCEL;
	}

	public String getPassword() {
		return password;
	}

}
